## Generate coupon codes

### cURL

```bash
curl --request POST \
  --url https://live.copilot.fabric.inc/api-offers/coupon/generate-codes \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \
  --data '
{
  "prefix": "SUMMER",
  "start": 1,
  "count": 3
}
'```

### Python

```python
import requests

url = "https://live.copilot.fabric.inc/api-offers/coupon/generate-codes"

payload = {
    "prefix": "SUMMER",
    "start": 1,
    "count": 3
}
headers = {
    "x-site-context": "<x-site-context>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
```

### JavaScript (Fetch)

```javascript
const options = {
  method: 'POST',
  headers: {
    'x-site-context': '<x-site-context>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({prefix: 'SUMMER', start: 1, count: 3})
};

fetch('https://live.copilot.fabric.inc/api-offers/coupon/generate-codes', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
```

### PHP

```php


```

### Response Codes

- **200** - OK
- **400** - Bad request
- **500** - Internal server error.

### Example Responses

#### Success Response

```json
{
  "codes": [
    "SUMMER1",
    "SUMMER2",
    "SUMMER3"
  ]
}
```

#### Error Response

```json
{
  "code": "BAD_REQUEST",
  "message": "Bad Request"
}
```

```json
{
  "code": "INTERNAL_SERVER_ERROR",
  "message": "Internal server error."
}
```

### Authorizations
- **Authorization**: Bearer authentication header of the form `Bearer <token>`, where `<token>` is your auth token.

### Headers
- **x-site-context**: Required JSON object that contains information about the source you wish to pull from, including the account and other optional narrowing parameters.
